﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.DataVisualization.DiagramEnums;
using Syncfusion.JavaScript.DataVisualization.Models;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.DataVisualization.Models.Collections;
using MvcApplication60.Models;
using System.Data.Entity.Validation;
using Syncfusion.JavaScript.DataVisualization.Models.Diagram;

namespace MvcApplication60.Controllers
{
    public class EntityController : Controller
    {
        //
        // GET: /Entity/
        string sn, sn1;
        DiagramProperties model = new DiagramProperties();
        public ActionResult Index()
        {
            model.Width = "1300px";
            model.Height = "1000px";
            Node node = new Node();
            node.Name = "Rectangle";
            node.Width = 50;
            node.Height = 50;
            node.OffsetX = 200;
            node.OffsetY = 200;             
            Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label label = new Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label();
            label.Text = "HeadNode";
            node.Labels.Add(label);
            model.Nodes.Add(node);
            Node node1 = new Node();
            node1.Name = "Ellipse";
            node1.Width = 50;
            node1.Height = 50;
            node1.OffsetX = 400;
            node1.OffsetY = 200;
            Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label label1 = new Syncfusion.JavaScript.DataVisualization.Models.Diagram.Label();
            label1.Text = "TailNode";
            node1.Labels.Add(label1);
            model.Nodes.Add(node1);
            connectnodes(node, node1);
            SymbolPaletteProperties symbolpalette = new SymbolPaletteProperties();
            symbolpalette.Height = "100%";
            symbolpalette.Width = "100%";
            symbolpalette.PaletteItemHeight = 45;
            symbolpalette.PaletteItemWidth = 45;
            symbolpalette.ShowPaletteItemText = true;
            symbolpalette.DiagramId = "diagram1";
            symbolpalette.HeaderHeight = 30;
            symbolpalette.AllowDrag = true;
            GenerateBasicShapes(symbolpalette);
            GenerateConnectors(symbolpalette);
            ViewData["SymbolPaletteModel"] = symbolpalette;
            ViewData["diagramModel"] = model;
            return View();
        }
        private void GenerateBasicShapes(SymbolPaletteProperties symbolPalette)
        {
            Palette basicShapes = new Palette("Basic Shapes");
            BasicShape node = new BasicShape();
            node.Name = "Rectangle";
            node.Width = 100;
            node.Height = 100;
            node.Shape =  BasicShapes.Rectangle;
            node.CornerRadius = 5;
            basicShapes.AppendChild(node);
            BasicShape node1 = new BasicShape();
            node1.Name = "Ellipse";
            node1.Width = 100;
            node1.Height = 100;
            node1.Shape = BasicShapes.Ellipse;
            basicShapes.AppendChild(node1);
            BasicShape node2 = new BasicShape();
            node2.Name = "path";
            node2.Width = 100;
            node2.Height = 100;
            node2.Shape = BasicShapes.Path;
            node2.PathData = "M 45 220 L 45 220 A 20 30 0 0 1 45 280 L 45 280 A 20 30 0 0 1 45 220 Z";
            basicShapes.AppendChild(node2);
            BasicShape node3 = new BasicShape();
            node3.Name = "path1";
            node3.Width = 100;
            node3.Height = 100;
            node3.Shape = BasicShapes.Path;
            node3.PathData = "M49.9984,50.0029 L-0.00271199,50.0029 L-0.00271199,0.00286865 L49.9984,0.00286865";
            basicShapes.AppendChild(node3);
            BasicShape node4 = new BasicShape();
            node4.Name = "path2";
            node4.Width = 100;
            node4.Height = 100;
            node4.Shape = BasicShapes.Path;
            node4.PathData = "M50.001,24.9971 L25.001,49.9971 L0.000976562,24.9971 L25.001,-0.00286865 L50.001,24.9971 z M0.000976562,24.9971 L50.001,24.9971";
            basicShapes.AppendChild(node4);
            symbolPalette.Palettes.Add(basicShapes);
        }
        private void GenerateConnectors(SymbolPaletteProperties symbolPalette)
        {
            Palette connectors = new Palette("Connectors");
            Connector connector = new Connector();
            connector.Name = "Orthogonal";
            Segment seg = new Syncfusion.JavaScript.DataVisualization.Models.Diagram.Segment(Segments.Orthogonal);
            connector.Segments.Add(seg);
            connector.SourcePoint = new DiagramPoint(0, 0);
            connector.TargetPoint = new DiagramPoint(40, 40);
            connectors.AppendChild(connector);
            Connector connector1 = new Connector();
            connector1.Name = "Straight";
            Segment seg1 = new Syncfusion.JavaScript.DataVisualization.Models.Diagram.Segment(Segments.Straight);
            connector1.Segments.Add(seg1);
            connector1.SourcePoint = new DiagramPoint(0, 0);
            connector1.TargetPoint = new DiagramPoint(40, 40);
            connectors.AppendChild(connector1);
            Connector connector2 = new Connector();
            connector2.Name = "Bezier";
            Segment seg2 = new Syncfusion.JavaScript.DataVisualization.Models.Diagram.Segment(Segments.Bezier);
            connector2.Segments.Add(seg2);
            connector2.SourcePoint = new DiagramPoint(0, 0);
            connector2.TargetPoint = new DiagramPoint(40, 40);
            connectors.AppendChild(connector2);
            symbolPalette.Palettes.Add(connectors);
        }

        [HttpPost]
        public ActionResult save(string ff)
        {
                NorthwindcontextsDiagramEntities entities = new NorthwindcontextsDiagramEntities();
                SaveDatabase gh = new SaveDatabase();
                gh.Diagram2 = ff;
                gh.Diagram3 = "dwd";
                entities.SaveDatabases.Add(gh);
                entities.SaveChanges();
            return null;
        }
        [HttpPost]
        public ActionResult load()
        {
            NorthwindcontextsDiagramEntities entities = new NorthwindcontextsDiagramEntities();
            entities = SqlCE;
            List<SaveDatabase> kk = entities.SaveDatabases.ToList<SaveDatabase>();
            foreach (SaveDatabase it in kk)
            {
                sn = it.Diagram2;
                sn1 = it.Diagram3;
            }
            string gg = sn;
            return Content(gg);
        }
        
        private void connectnodes(Node sourcenode, Node targetnode)
        {
            Connector connector = new Connector();
            connector.Name = "line" + model.Connectors.Count;
            Segment segment = new Segment();
            segment.Type = Segments.Orthogonal;
            connector.Segments.Add(segment); 
            connector.SourceNode = sourcenode.Name;
            connector.TargetNode = targetnode.Name;
            model.Connectors.Add(connector);
        }
        

        public NorthwindcontextsDiagramEntities SqlCE
        {
            get
            {
                AppDomain.CurrentDomain.SetData("SQLServerCompactEditionUnderWebHosting", true);
                string connectionString = @"Data Source=|DataDirectory|\Diagram.sdf";
                return new NorthwindcontextsDiagramEntities(connectionString);
            }
        }
    }
}
